GeoDegenerateVerticalLine (Lucene 10.5.1 spatial3d API)
Description: declaration: package: org.apache.lucene.spatial3d.geom, class: GeoDegenerateVerticalLine

Package org.apache.lucene.spatial3d.geom

# Class GeoDegenerateVerticalLine

java.lang.Object
org.apache.lucene.spatial3d.geom.BasePlanetObject
org.apache.lucene.spatial3d.geom.GeoBaseBounds
org.apache.lucene.spatial3d.geom.GeoBaseShape
org.apache.lucene.spatial3d.geom.GeoBaseMembershipShape
org.apache.lucene.spatial3d.geom.GeoDegenerateVerticalLine

All Implemented Interfaces:
  `Bounded`, `GeoArea`, `GeoAreaShape`, `GeoBBox`, `GeoBounds`, `GeoMembershipShape`, `GeoOutsideDistance`, `GeoShape`, `GeoSizeable`, `Membership`, `PlanetObject`, `SerializableObject`

public class GeoDegenerateVerticalLine extends GeoBaseMembershipShape
Degenerate bounding box limited on two sides (top lat, bottom lat).

NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected static final int`
  `ALL_INSIDE`
  All edgepoints inside shape
  `protected final double`
  `bottomLat`
  Bottom latitude of the vertical line
  `protected final SidedPlane`
  `bottomPlane`
  Bottom end cutoff plane
  `protected final SidedPlane`
  `boundingPlane`
  Back-side cutoff plane
  `protected final GeoPoint`
  `centerPoint`
  A computed center point for the line
  `protected final GeoPoint[]`
  `edgePoints`
  A point that's on the line
  `protected final GeoPoint`
  `LHC`
  Point at the lower end of the vertical line
  `protected final double`
  `longitude`
  Longitude of the vertical line
  `protected static final int`
  `NONE_INSIDE`
  No edgepoints inside shape
  `protected final Plane`
  `plane`
  The vertical line plane
  `protected final GeoPoint[]`
  `planePoints`
  Notable points for the line (end points)
  `protected static final int`
  `SOME_INSIDE`
  Some edgepoints inside shape
  `protected final double`
  `topLat`
  Top latitude of the vertical line
  `protected final SidedPlane`
  `topPlane`
  Top end cutoff plane
  `protected final GeoPoint`
  `UHC`
  Point at the upper end of the vertical line

  ### Fields inherited from class org.apache.lucene.spatial3d.geom.BasePlanetObject

  `planetModel`

  ### Fields inherited from interface org.apache.lucene.spatial3d.geom.GeoArea

  `CONTAINS, DISJOINT, OVERLAPS, WITHIN`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `GeoDegenerateVerticalLine(PlanetModel planetModel, double topLat, double bottomLat, double longitude)`
  Accepts only values in the following ranges: lat: `-PI/2 -> PI/2`, longitude: `-PI -> PI`
  `GeoDegenerateVerticalLine(PlanetModel planetModel, InputStream inputStream)`
  Constructor for deserialization.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `equals(Object o)`
  `GeoBBox`
  `expand(double angle)`
  Expand box by specified angle.
  `void`
  `getBounds(Bounds bounds)`
  Compute bounds for the shape.
  `GeoPoint`
  `getCenter()`
  Returns the center of a circle into which the area will be inscribed.
  `GeoPoint[]`
  `getEdgePoints()`
  Return a sample point that is on the outside edge/boundary of the shape.
  `double`
  `getRadius()`
  Returns the radius of a circle into which the GeoSizeable area can be inscribed.
  `int`
  `getRelationship(GeoShape path)`
  Find the spatial relationship between a shape and the current geo area.
  `int`
  `hashCode()`
  `boolean`
  `intersects(GeoShape geoShape)`
  Assess whether a shape intersects with any of the edges of this shape.
  `boolean`
  `intersects(Plane p, GeoPoint[] notablePoints, Membership... bounds)`
  Assess whether a plane, within the provided bounds, intersects with the shape's edges.
  `protected int`
  `isGeoAreaShapeInsideShape(GeoShape geoshape)`
  Determine the relationship between the GeoAreaShape's edgepoints and the provided shape.
  `protected int`
  `isShapeInsideGeoAreaShape(GeoShape geoShape)`
  Determine the relationship between the GeoAreShape and the shape's edgepoints.
  `boolean`
  `isWithin(double x, double y, double z)`
  Check if a point is within this shape.
  `protected double`
  `outsideDistance(DistanceStyle distanceStyle, double x, double y, double z)`
  Called by a `computeOutsideDistance` method if X/Y/Z is not within this shape.
  `String`
  `toString()`
  `void`
  `write(OutputStream outputStream)`
  Serialize to output stream.

  ### Methods inherited from class org.apache.lucene.spatial3d.geom.GeoBaseMembershipShape

  `computeOutsideDistance, computeOutsideDistance, isWithin`

  ### Methods inherited from class org.apache.lucene.spatial3d.geom.BasePlanetObject

  `getPlanetModel`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface org.apache.lucene.spatial3d.geom.GeoOutsideDistance

  `computeOutsideDistance, computeOutsideDistance`

  ### Methods inherited from interface org.apache.lucene.spatial3d.geom.Membership

  `isWithin`

  ### Methods inherited from interface org.apache.lucene.spatial3d.geom.PlanetObject

  `getPlanetModel`

- ## Field Details

  - ### topLat

    protected final double topLat
    Top latitude of the vertical line

  - ### bottomLat

    protected final double bottomLat
    Bottom latitude of the vertical line

  - ### longitude

    protected final double longitude
    Longitude of the vertical line

  - ### UHC

    protected final GeoPoint UHC
    Point at the upper end of the vertical line

  - ### LHC

    protected final GeoPoint LHC
    Point at the lower end of the vertical line

  - ### topPlane

    protected final SidedPlane topPlane
    Top end cutoff plane

  - ### bottomPlane

    protected final SidedPlane bottomPlane
    Bottom end cutoff plane

  - ### boundingPlane

    protected final SidedPlane boundingPlane
    Back-side cutoff plane

  - ### plane

    protected final Plane plane
    The vertical line plane

  - ### planePoints

    protected final GeoPoint[] planePoints
    Notable points for the line (end points)

  - ### centerPoint

    protected final GeoPoint centerPoint
    A computed center point for the line

  - ### edgePoints

    protected final GeoPoint[] edgePoints
    A point that's on the line

  - ### ALL_INSIDE

    protected static final int ALL_INSIDE
    All edgepoints inside shape
    See Also:
      - Constant Field Values

  - ### SOME_INSIDE

    protected static final int SOME_INSIDE
    Some edgepoints inside shape
    See Also:
      - Constant Field Values

  - ### NONE_INSIDE

    protected static final int NONE_INSIDE
    No edgepoints inside shape
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### GeoDegenerateVerticalLine

    public GeoDegenerateVerticalLine(PlanetModel planetModel, double topLat, double bottomLat, double longitude)
    Accepts only values in the following ranges: lat: `-PI/2 -> PI/2`, longitude: `-PI -> PI`

  - ### GeoDegenerateVerticalLine

    public GeoDegenerateVerticalLine(PlanetModel planetModel, InputStream inputStream) throws IOException
    Constructor for deserialization.
    Parameters:
      `planetModel` - is the planet model.
      `inputStream` - is the input stream.
    Throws:
      `IOException`

- ## Method Details

  - ### write

    public void write(OutputStream outputStream) throws IOException
    Description copied from interface: `SerializableObject`
    Serialize to output stream.
    Specified by:
      `write` in interface `SerializableObject`
    Overrides:
      `write` in class `BasePlanetObject`
    Parameters:
      `outputStream` - is the output stream to write to.
    Throws:
      `IOException`

  - ### expand

    public GeoBBox expand(double angle)
    Description copied from interface: `GeoBBox`
    Expand box by specified angle.
    Parameters:
      `angle` - is the angle amount to expand the GeoBBox by.
    Returns:
      a new GeoBBox.

  - ### isWithin

    public boolean isWithin(double x, double y, double z)
    Description copied from interface: `Membership`
    Check if a point is within this shape.
    Parameters:
      `x` - is x coordinate of point to check.
      `y` - is y coordinate of point to check.
      `z` - is z coordinate of point to check.
    Returns:
      true if the point is within this shape

  - ### getRadius

    public double getRadius()
    Description copied from interface: `GeoSizeable`
    Returns the radius of a circle into which the GeoSizeable area can be inscribed.
    Returns:
      the radius.

  - ### getCenter

    public GeoPoint getCenter()
    Description copied from interface: `GeoSizeable`
    Returns the center of a circle into which the area will be inscribed.
    Returns:
      the center.

  - ### getEdgePoints

    public GeoPoint[] getEdgePoints()
    Description copied from interface: `GeoShape`
    Return a sample point that is on the outside edge/boundary of the shape.
    Returns:
      samples of all edge points from distinct edge sections. Typically one point is returned, but zero or two are also possible.

  - ### intersects

    public boolean intersects(Plane p, GeoPoint[] notablePoints, Membership... bounds)
    Description copied from interface: `GeoShape`
    Assess whether a plane, within the provided bounds, intersects with the shape's edges. Any overlap, even a single point, is considered to be an intersection. Note well that this method is allowed to return "true" if there are internal edges of a composite shape which intersect the plane. Doing this can cause getRelationship() for most GeoBBox shapes to return OVERLAPS rather than the more correct CONTAINS, but that cannot be helped for some complex shapes that are built out of overlapping parts.
    Parameters:
      `p` - is the plane to assess for intersection with the shape's edges or bounding curves.
      `notablePoints` - represents the intersections of the plane with the supplied bounds. These are used to disambiguate when two planes are identical and it needs to be determined whether any points exist that fulfill all the bounds.
      `bounds` - are a set of bounds that define an area that an intersection must be within in order to qualify (provided by a GeoArea).
    Returns:
      true if there's such an intersection, false if not.

  - ### intersects

    public boolean intersects(GeoShape geoShape)
    Description copied from interface: `GeoAreaShape`
    Assess whether a shape intersects with any of the edges of this shape. Note well that this method must return false if the shape contains or is disjoint with the given shape. It is permissible to return true if the shape is within the specified shape, if it is difficult to compute intersection with edges.
    Parameters:
      `geoShape` - is the shape to assess for intersection with this shape's edges.
    Returns:
      true if there's such an intersection, false if not.

  - ### getBounds

    public void getBounds(Bounds bounds)
    Description copied from interface: `Bounded`
    Compute bounds for the shape.
    Specified by:
      `getBounds` in interface `Bounded`
    Overrides:
      `getBounds` in class `GeoBaseBounds`
    Parameters:
      `bounds` - is the input bounds object. The input object will be modified.

  - ### getRelationship

    public int getRelationship(GeoShape path)
    Description copied from interface: `GeoArea`
    Find the spatial relationship between a shape and the current geo area. Note: return value is how the GeoShape relates to the GeoArea, not the other way around. For example, if this GeoArea is entirely within the shape, then CONTAINS should be returned. If the shape is entirely enclosed by this GeoArea, then WITHIN should be returned.

    It is permissible to return OVERLAPS instead of WITHIN if the shape intersects with the area at even a single point. So, a circle inscribed in a rectangle could return either OVERLAPS or WITHIN, depending on implementation. It is not permissible to return CONTAINS or DISJOINT in this circumstance, however.

    Similarly, it is permissible to return OVERLAPS instead of CONTAINS under conditions where the shape consists of multiple independent overlapping subshapes, and the area overlaps one of the subshapes. It is not permissible to return WITHIN or DISJOINT in this circumstance, however.

    Specified by:
      `getRelationship` in interface `GeoArea`
    Parameters:
      `path` - is the shape to consider.
    Returns:
      the relationship, from the perspective of the shape.

  - ### outsideDistance

    protected double outsideDistance(DistanceStyle distanceStyle, double x, double y, double z)
    Description copied from class: `GeoBaseMembershipShape`
    Called by a `computeOutsideDistance` method if X/Y/Z is not within this shape.
    Specified by:
      `outsideDistance` in class `GeoBaseMembershipShape`

  - ### equals

    public boolean equals(Object o)
    Overrides:
      `equals` in class `BasePlanetObject`

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `BasePlanetObject`

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`

  - ### isShapeInsideGeoAreaShape

    protected int isShapeInsideGeoAreaShape(GeoShape geoShape)
    Determine the relationship between the GeoAreShape and the shape's edgepoints.
    Parameters:
      `geoShape` - is the shape.
    Returns:
      the relationship.

  - ### isGeoAreaShapeInsideShape

    protected int isGeoAreaShapeInsideShape(GeoShape geoshape)
    Determine the relationship between the GeoAreaShape's edgepoints and the provided shape.
    Parameters:
      `geoshape` - is the shape.
    Returns:
      the relationship.